# class Chef::ReservedNames::Win32::Handle

### Constants

CURRENT_PROCESS_HANDLE

  See msdn.microsoft.com/en-us/library/windows/desktop/ms683179(v=vs.85).aspx The handle value returned by the GetCurrentProcess function is the pseudo handle (HANDLE)-1 (which is 0xFFFFFFFF)

### Attributes

handle[R]

### Public Class Methods

close_handle(handle) click to toggle source

    # File lib/chef/win32/handle.rb, line 47
    def self.close_handle(handle)
      unless CloseHandle(handle)
        Chef::ReservedNames::Win32::Error.raise!
      end
    end

close_handle_finalizer(handle) click to toggle source

    # File lib/chef/win32/handle.rb, line 40
    def self.close_handle_finalizer(handle)
      # According to http://msdn.microsoft.com/en-us/library/windows/desktop/ms683179(v=vs.85).aspx, it is not necessary
      # to close the pseudo handle returned by the GetCurrentProcess function.  The docs also say that it doesn't hurt to call
      # CloseHandle on it. However, doing so from inside of Ruby always seems to produce an invalid handle error.
      proc { close_handle(handle) unless handle == CURRENT_PROCESS_HANDLE }
    end

new(handle) click to toggle source

    # File lib/chef/win32/handle.rb, line 33
    def initialize(handle)
      @handle = handle
      ObjectSpace.define_finalizer(self, Handle.close_handle_finalizer(handle))
    end